unit Palette;

interface

uses Graphics;

procedure FadeIn;
procedure FadeOut;
procedure SetAllPal;
procedure SetNullPal;
procedure SetRGBPal(n, r, g, b: Byte);
procedure ScrollPal(Start, Len: Integer);

var Pal: array[0..1023] of Byte;

implementation

procedure SetRGBPal(n, r, g, b: Byte);
begin
  Pal[n * 4 + 2] := r;
  Pal[n * 4 + 1] := g;
  Pal[n * 4] := b;
end;

procedure SetAllPal;
  var i: Integer;
begin
  for i := 1 to 255 do
    SetRGB(i, Pal[i * 4 + 2], Pal[i * 4 + 1], Pal[i * 4]);
end;

procedure SetNullPal;
  var i: Integer;
begin
  for i := 0 to 255 do
    SetRGB(i, 0, 0, 0);
end;

function DivPal(b: Byte; n: Integer): Byte;
begin
  DivPal := (((b * 100) div 63) * n) div 100;
end;

procedure FadeIn;
  var i, j: Integer;
      R, G, B: Byte;
begin
  for j := 0 to 63 do begin
    for i := 1 to 255 do begin
      R := DivPal(Pal[i * 4 + 2], j);
      G := DivPal(Pal[i * 4 + 1], j);
      B := DivPal(Pal[i * 4], j);
      SetRGB(i, R, G, B);
    end;
    VertRet;
  end;
end;

procedure FadeOut;
  var i, j: Integer;
      R, G, B: Byte;
begin
  for j := 63 downto 0 do begin
    for i := 1 to 255 do begin
      R := DivPal(Pal[i * 4 + 2], j);
      G := DivPal(Pal[i * 4 + 1], j);
      B := DivPal(Pal[i * 4], j);
      SetRGB(i, R, G, B);
    end;
    VertRet;
  end;
end;

procedure ScrollPal(Start, Len: Integer);
  var i: Integer;
      R, G, B: Byte;
begin
  R := Pal[(Start + Len) * 4 + 2];
  G := Pal[(Start + Len) * 4 + 1];
  B := Pal[(Start + Len) * 4];

  for i := Len downto 1 do begin
    SetRGB(i + Start, Pal[(i - 1 + Start) * 4 + 2], Pal[(i - 1 + Start) * 4 + 1], Pal[(i - 1 + Start) * 4]);
    SetRGBPal(i + Start, Pal[(i - 1 + Start) * 4 + 2], Pal[(i - 1 + Start) * 4 + 1], Pal[(i - 1 + Start) * 4]);
  end;

  SetRGB(Start, R, G, B);
  SetRGBPal(Start, R, G, B);
end;

end.
